# SoTransform Class Reference
[Nodes]

`#include <Inventor/nodes/SoTransform.h>`

Inheritance diagram for SoTransform:

List of all members.

## Detailed Description

The SoTransform class is the "all-purpose" transformation node type.

Like SoMatrixTransform, nodes of this type gives the application programmer maximum flexibility when specifying geometry transformations in a scene graph. If you want to set and keep the various components of the transformation matrix in separate entities, this node type is preferable, though.

The order of operations is: first scaling is done, then rotation, then translation.

## Public Member Functions

| SoTransform (void)
void | pointAt (const SbVec3f &frompoint, const SbVec3f &topoint)
void | getScaleSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getRotationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getTranslationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | multLeft (const SbMatrix &mat)
void | multRight (const SbMatrix &mat)
void | combineLeft (SoTransformation *nodeonright)
void | combineRight (SoTransformation *nodeonleft)
void | setMatrix (const SbMatrix &mat)
void | recenter (const SbVec3f &newcenter)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFVec3f | translation
SoSFRotation | rotation
SoSFVec3f | scaleFactor
SoSFRotation | scaleOrientation
SoSFVec3f | center

## Protected Member Functions

virtual | ~SoTransform ()

## Constructor & Destructor Documentation

SoTransform::SoTransform | ( | void |  | ) |

| Constructor.

SoTransform::~SoTransform | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoTransform::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoTransformation. Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, SoTransformManip, and SoTransformerManip.

void SoTransform::pointAt | ( | const SbVec3f & | frompoint,
|  | const SbVec3f & | topoint
| ) |

| Sets the transformation to translate to frompoint, with a rotation so that the (0,0,-1) vector is rotated into the vector from frompoint to topoint.

void SoTransform::getScaleSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv
| ) | const

| Calculates the matrices to/from scale space.

void SoTransform::getRotationSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv
| ) | const

| Calculates the matrices to/from rotation space.

void SoTransform::getTranslationSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv
| ) | const

| Calculates the matrices to/from translation space.

void SoTransform::multLeft | ( | const SbMatrix & | mat | ) |

| Premultiplies this transformation by mat.

void SoTransform::multRight | ( | const SbMatrix & | mat | ) |

| Postmultiplies this transformation by mat.

void SoTransform::combineLeft | ( | SoTransformation * | nodeonright | ) |

| Premultiplies this transformation by the transformation in nodeonright.

void SoTransform::combineRight | ( | SoTransformation * | nodeonleft | ) |

| Postmultiplies this transformation by the transformation in nodeonleft.

void SoTransform::setMatrix | ( | const SbMatrix & | mat | ) |

| Sets the fields to create a transformation equal to mat.

void SoTransform::recenter | ( | const SbVec3f & | newcenter | ) |

| Sets the center field to newcenter. This might affect one or more of the other fields.

void SoTransform::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode. Reimplemented in SoTransformManip.

void SoTransform::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode. Reimplemented in SoTransformManip.

void SoTransform::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode. Reimplemented in SoTransformManip.

void SoTransform::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

void SoTransform::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoNode. Reimplemented in SoTransformManip.

void SoTransform::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode. Reimplemented in SoTransformManip.

void SoTransform::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

## Member Data Documentation

SoSFVec3f SoTransform::translation

| The translation part of the transformation.

SoSFRotation SoTransform::rotation

The rotation part of the transformation.

Note that there is one very common mistake that is easy to make when setting the value of a an SoSFRotation field, and that is to inadvertently use the wrong SbRotation constructor. This example should clarify the problem:

      mytransformnode->rotation.setValue(0, 0, 1, 1.5707963f);

The programmer clearly tries to set a PI/2 rotation around the Z axis, but this will fail, as the SbRotation constructor invoked above is the one that takes as arguments the 4 floats of a quaternion. What the programmer almost certainly wanted to do was to use the SbRotation constructor that takes a rotation vector and a rotation angle, which is invoked like this:

      mytransformnode->rotation.setValue(SbVec3f(0, 0, 1), 1.5707963f);

SoSFVec3f SoTransform::scaleFactor

| The scaling part of the transformation.

SoSFRotation SoTransform::scaleOrientation

| The orientation the object is set to before scaling.

SoSFVec3f SoTransform::center

| The center point for the rotation.

The documentation for this class was generated from the following files:

- SoTransform.h
- SoTransform.cpp